HDOJ4825-Xor Sum(贪心 + Trie + 位运算)

Problem Description

Zeus 和 Prometheus 做了一个游戏,Prometheus 给 Zeus 一个集合,集合中包含了N个正整数,随后 Prometheus 将向 Zeus 发起M次询问,每次询问中包含一个正整数 S ,之后 Zeus 需要在集合当中找出一个正整数 K ,使得 K 与 S 的异或结果最大。Prometheus 为了让 Zeus 看到人类的伟大,随即同意 Zeus 可以向人类求助。你能证明人类的智慧么?

Input

输入包含若干组测试数据,每组测试数据包含若干行。输入的第一行是一个整数T(T < 10),表示共有T组数据。每组数据的第一行输入两个正整数N,M(<1=N,M<=100000),接下来一行,包含N个正整数,代表 Zeus 的获得的集合,之后M行,每行一个正整数S,代表 Prometheus 询问的正整数。所有正整数均不超过2^32。

Output

对于每组数据,首先需要输出单独一行”Case #?:”,其中问号处应填入当前的数据组数,组数从1开始计算。对于每个询问,输出一个正整数K,使得K与S异或值最大。

Sample Input

2
3 2
3 4 5
1
5
4 1
4 6 5 6
3

Sample Output

Case #1:
4
3
Case #2:
4

Code:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 int t;
 4 typedef long long LL;
 5 int n , m;
 6 struct Node
 7 {
 8     Node* next[2];
 9     Node()
10     {
11         memset(next , NULL , sizeof(next));
12     }
13 };
14
15 void Insert(int s , Node* root)
16 {
17     Node* p = root;
18     for(int i = 31 ; i >= 0 ; --i)
19     {
20         int id = ((s & (1 << i)) != 0);
21         if(p->next[id] == NULL)
22             p->next[id] = new Node();
23         p = p->next[id];
24     }
25 }
26 int Query(int s , Node* root)
27 {
28     Node* p = root;
29     int ans = 0;
30     for(int i = 31 ; i >= 0 ; --i)
31     {
32         int id = ((s & (1 << i)) != 0);
33         if(p->next[id ^ 1])
34             ans |= (id ^ 1) << i , p = p->next[id ^ 1];
35         else
36             ans |= id << i , p = p->next[id];
37     }
38     return ans;
39 }
40 int main()
41 {
42     scanf("%d" , &t);
43     for(int c = 1 ; c <= t ; ++c)
44     {
45         Node* root = new Node();
46         scanf("%d%d" , &n , &m);
47         int x;
48         for(int i = 1 ; i <= n ; ++i)
49         {
50             scanf("%d" , &x);
51             Insert(x , root);
52         }
53
54         printf("Case #%d:\n" , c);
55         while(m--)
56         {
57             scanf("%d" , &x);
58             printf("%d\n" , Query(x , root));
59         }
60     }
61 }

时间: 2024-11-10 12:06:24

HDOJ4825-Xor Sum(贪心 + Trie + 位运算)的相关文章

HDU 4825 Xor Sum 字典树+位运算

点击打开链接 Xor Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 132768/132768 K (Java/Others) Total Submission(s): 291    Accepted Submission(s): 151 Problem Description Zeus 和 Prometheus 做了一个游戏,Prometheus 给 Zeus 一个集合,集合中包含了N个正整数,随后 Prometheus

Xor Sum 2(位运算)

D - Xor Sum 2 Time limit : 2sec / Memory limit : 1024MB Score : 500 points Problem Statement There is an integer sequence A of length N. Find the number of the pairs of integers l and r (1≤l≤r≤N) that satisfy the following condition: Al xor Al+1 xor 

hdu 4825 xor sum(字典树+位运算)

Xor Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 132768/132768 K (Java/Others)Total Submission(s): 4144    Accepted Submission(s): 1810 Problem Description Zeus 和 Prometheus 做了一个游戏,Prometheus 给 Zeus 一个集合,集合中包含了N个正整数,随后 Prometheus 将向 Ze

HDU4825 Xor Sum(贪心+Trie树)

今天本来想写一个可持久化Trie树,发现这道题一直没做就补上了. 其实思路很简单,假如说两个数,和同一个数异或,很显然,由于进制,高位上的一个1可以大于低位上所有1,所以即使后面的情况再糟糕,也比取后面好的值高(其实就是1000比0111大) 所以可以建一个01线段树,从高往低插入一个数,比较时取反即可^_^ 1 #include<cstdio> 2 #include<cstring> 3 #include<algorithm> 4 using namespace st

HDU 4825:Xor Sum(Trie)

http://acm.hdu.edu.cn/showproblem.php?pid=4825 题意:给出N个数,M个询问,每个询问给出一个X,问在这N个数中哪个数和X异或后结果最大. 思路:可以用Trie构造出sigmaSize为0和1的点,先将N个数插入Trie,然后询问在Trie上尽量找可以不同的数,不同的话异或起来是最大的. 1 #include <cstdio> 2 #include <algorithm> 3 #include <iostream> 4 #in

BZOJ 3668 [Noi2014]起床困难综合症 贪心+位运算

前言:he- - 听说这是到水题,然而我考试的时候并没有做出来(自己太弱说个毛),总而言之吧,这道题告诉我: "位运算每一位互相不会干扰!!你丫这都想不到!太弱!!" 题意:链接 方法:贪心?+位运算 解析:考试的时候不知道位运算每一位不互相干扰(我真是"bi",这都想不到). 好吧然后这题就很好搞了,int找到31位,然后从后往前枚举,算每一位答案中取1或0的值,然后这个值对应这一位是1的话,只要检验答案加上这个值是不是超过m就可以了,就是这么个非常简单的贪心思路

hdu 4825 Xor Sum(trie+贪心)

hdu 4825 Xor Sum(trie+贪心) 刚刚补了前天的CF的D题再做这题感觉轻松了许多.简直一个模子啊...跑树上异或x最大值.贪心地让某位的值与x对应位的值不同即可. 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <algorithm> 5 #include <cmath> 6 #define CLR(a,b) memset((a)

HDU 4825 Xor Sum(经典01字典树+贪心)

Xor Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 132768/132768 K (Java/Others) Total Submission(s): 1555    Accepted Submission(s): 657 Problem Description Zeus 和 Prometheus 做了一个游戏,Prometheus 给 Zeus 一个集合,集合中包含了N个正整数,随后 Prometheus 将向 Ze

[leetcode] Sum of Two Integers--用位运算实现加法运算

问题: Calculate the sum of two integers a and b, but you are not allowed to use the operator + and -. Example: Given a = 1 and b = 2, return 3. 分析: 这里要求我们不能用加法.减法等运算符来实现加法运算.这里应该使用位运算来实现加法运算,实际上,这也是计算机CPU内部实现加法运算的方案. x XOR y真值表: x y output 0 0 0 0 1 1